# emulatore tasto ENTER da tasto verticale e/o tasto Paddle
# programma realizzato da IT9SAJ ed implementato da Riccardo
# L'utilizzo e gratuito

import digitalio
import board
import time
import usb_hid
from adafruit_hid.keyboard import Keyboard
from adafruit_hid.keycode import Keycode
import analogio

led = digitalio.DigitalInOut(board.LED)
led.direction = digitalio.Direction.OUTPUT
key_out = digitalio.DigitalInOut(board.GP15)
key_out.direction = digitalio.Direction.OUTPUT
key_in = digitalio.DigitalInOut(board.GP16)
key_in.switch_to_input(pull=digitalio.Pull.DOWN)
key_dot = digitalio.DigitalInOut(board.GP4)
key_dot.switch_to_input(pull=digitalio.Pull.DOWN)
key_dash = digitalio.DigitalInOut(board.GP5)
key_dash.switch_to_input(pull=digitalio.Pull.DOWN)
keyboard = Keyboard(usb_hid.devices)
pot_read = analogio.AnalogIn(board.GP28_A2)
igce = 0

key_out.value = True  # pin GP15 su TRUE
led.value = False

speed = 0.11

# lampeggioIniziale
for it9saj in range(1, 20):
    led.value = it9saj % 2
    time.sleep(0.2)
    igce = 0

while True:
    print(pot_read.value, speed)

    speed = pot_read.value * 3.3 / 330000
    if (key_in.value):
        led.value = True
        keyboard.press(Keycode.RETURN)

    elif (key_dot.value) and (key_dash.value) and igce == 2:
        led.value = True
        keyboard.press(Keycode.RETURN)
        time.sleep(speed)
        led.value = False
        keyboard.release(Keycode.RETURN)
        time.sleep(speed)
        led.value = True
        keyboard.press(Keycode.RETURN)
        time.sleep(speed * 3)
        led.value = False
        keyboard.release(Keycode.RETURN)
        time.sleep(speed * 0.7)

    elif (key_dot.value) and (key_dash.value) and igce == 1: 
        led.value = True
        keyboard.press(Keycode.RETURN)
        time.sleep(speed * 3)
        led.value = False
        keyboard.release(Keycode.RETURN)
        time.sleep(speed * 0.7)
        led.value = True
        keyboard.press(Keycode.RETURN)
        time.sleep(speed)
        led.value = False
        keyboard.release(Keycode.RETURN)
        time.sleep(speed)

    elif (key_dot.value):
        igce = 1
        led.value = True
        keyboard.press(Keycode.RETURN)
        time.sleep(speed)
        led.value = False
        keyboard.release(Keycode.RETURN)
        time.sleep(speed)

    elif (key_dash.value):
        igce = 2
        led.value = True
        keyboard.press(Keycode.RETURN)
        time.sleep(speed * 3)
        led.value = False
        keyboard.release(Keycode.RETURN)
        time.sleep(speed * 0.7)

    else:
        led.value = False
        keyboard.release(Keycode.RETURN)
        igce = 0
